;|									;;
			D L E D I T					;;
		Dynamic Line Editor v. 1.5				;;
		By Andrea Andreetti	2008/12/25			;;
									;;
		Update 1 - By A.A.					;;
			ai_table replaced by (getAvailableLinetypes)	;;
		Update 2 - By A.A.					;;
			Pline Width added (option W)			;;
		Update 3 - By A.A. with Ronjon (theswamp) suggestion	;;
			New feature to change Color of Layer		;;
		Update 4 - By A.A.					;;
			Entity transformed to polyline detection added	;;
		Update 5 - By A.A.					;;
			DLSL Dline String Language detection function	;;
									|;

(vl-load-com)
;;					;;
;;	FRENCH/ENGLISH DETECTION	;;
;;					;;
					;;
(defun DLSL ()
(if (vl-string-search "(FR)" (strcase (ver)))
  (progn
    (setq mess1   "\nSelectionnez votre entit  diter...")
    (setq mess2   "\n- Type de Ligne chang  : ")
    (setq mess3   "\n(E)chelle/(L)type de Ligne/(C)couleur:")
    (setq mess4   "\n(E)chelle/(L)type de Ligne/(C)couleur/e(P)aisseur:")
    (setq mess5   "\nChanger la couleur de l'(E)ntit ou du (C)alque ?:")
    (setq var256  "DUCALQUE")
    (setq var0    "DUBLOCK")
    (setq SL1 '(
		       15	;F8
		       108 76	;L
		       101 69	;E
		       99 67	;C
	       )
    )
    (SETQ SL2  '(112 80))	;p
)
  (progn   
    (setq mess1   "\nSelect Entity to Edit...")
    (setq mess2   "\n- Line type Switched to : ")
    (setq mess3   "\n(S)cale/(L)Line type/(C)olor:")
    (setq mess4   "\n(S)cale/(L)Line type/(C)olor/(W)idth:")
    (setq mess5   "\nChange the color of the (E)ntity or (L)ayer ?:")
    (setq var256  "BYLAYER")
    (setq var0    "BYBLOCK")
    (setq SL1 '(
		       15	;F8
		       108 76	;L
		       115 83	;S
		       99 67	;C
		    )
    )
    (SETQ SL2  '(119 87))	;w
  )
)
)
					;;
;;					;;
;;	FRENCH/ENGLISH DETECTION	;;
;;					;;



;;					;;
;;	DLedit 	COMMAND			;;
;;					;;
					;;
(defun c:DLedit (/ linedata ld_sel1 LLpoint objectent entALLOWED)
 
(DLSL)
(setq entVLA nil)
(setq OPT nil)  
(setq entALLOWED '("POLYLINE" "LWPOLYLINE" "LINE" "ARC" "CIRCLE" "SPLINE"))
(setq ld_sel1 nil)  
  (while   (or
           (= ld_sel1 nil)           
           (not (member (cdr (assoc 0 (entget (car ld_sel1)))) entALLOWED))           
	   )    
    (setq ld_sel1 (entsel mess1))    
  )

(setq linedata (entget (car ld_sel1)))
(setq entVLA (vlax-ename->vla-object (car ld_sel1)))
(setq centerpoint (cadr ld_sel1))  
(setq A_CELTscale (vla-get-LinetypeScale entVLA))
(setq A_LType     (vla-get-Linetype entVLA))
(setq A_CEColor   (vl-princ-to-string (vla-get-color entVLA)))
(setq A_Clayer	  (vla-get-layer entVLA))
  
(redraw)
(vla-StartUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
(DLexecute)  
(setq objectent nil)
(redraw)
(vla-EndUndoMark (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
(vlax-release-object entVLA)(setq entVLA nil)
)
					;;
;;					;;
;;	DLedit 	COMMAND			;;
;;					;;




;;				;;
;;	DLedit 	function	;;
;;				;;
				;;
(defun DLexecute (/ fi si LP Operation #dcswitch snapa orthm LTypelist)
(setvar "CMDECHO" 0)
(setq orthm (getvar "ORTHOMODE"))
(setq snapa (getvar "SNAPANG"))
(setq Operation nil)

(setq LTypelist (append (list "BYLAYER" "BYBLOCK")(getHatchLIN (findfile "acad.lin"))))
(setq #ofLTYPE (1- (vl-list-length LTypelist)))

(if (not (setq #dcswitch (vl-position A_Ltype LTypelist)))
(setq #dcswitch 0)
)


(if (or
      (eq (vla-get-ObjectName entVLA) "AcDbPolyline")
      (eq (vla-get-ObjectName entVLA) "AcDb2dPolyline")
    )
  (progn
  (setq SL1 (append SL1 SL2))
  (setq Pmess mess4)
  )
  (setq Pmess mess3)
)

(princ Pmess)  
    (while (and (setq input (grread t 4 4))		
                (or (= (car input) 5)				  ; *cursor
		    (and (= (car input) 2) (member (cadr input) SL1))   		    
                )
           )

     (redraw) 
(if (= (car input) 5) (setq cursorpoint (cadr input)))     
      
(if (and (= (car input) 2) (= (cadr input) 15)) (setq Operation "ORTHO"))
      
(if (or
      (and (= (car input) 2) (= (cadr input) 115));S
      (and (= (car input) 2) (= (cadr input) 83))
      (and (= (car input) 2) (= (cadr input) 101));E
      (and (= (car input) 2) (= (cadr input) 69))
    )
      (setq Operation "SCALE")
)
      
(if (or
      (and (= (car input) 2) (= (cadr input) 99))
      (and (= (car input) 2) (= (cadr input) 67))
    )
  (setq Operation "COLOR")
)

(if (or
      (and (= (car input) 2) (= (cadr input) 108))
      (and (= (car input) 2) (= (cadr input) 76))
    )
  (setq Operation "LINETYPE")
)

(if (and
      (or
      (eq (vla-get-ObjectName entVLA) "AcDbPolyline")
      (eq (vla-get-ObjectName entVLA) "AcDb2dPolyline")
      )
      (or
      (and (= (car input) 2) (= (cadr input) 119))
      (and (= (car input) 2) (= (cadr input) 87))
      (and (= (car input) 2) (= (cadr input) 112))
      (and (= (car input) 2) (= (cadr input) 80))
      )
    )
  (progn
  (setq Operation "WIDTH")
  (if (not OPT) ;(progn
;;;		  (alert (strcat "message 2: " Operation
;;;				 "\n" (vl-princ-to-string entVLA)
;;;				 "\n" (vl-princ-to-string cursorpoint)
;;;				 "\n" (vl-princ-to-string centerpoint)
;;;		          )
;;;		  )
                  (setq OPT T)
                ;)
  )
  )
)


;;ONwidht change		;;
				;;
(if (eq Operation "WIDTH")
     (progn
(setq A_Width (* (distance cursorpoint centerpoint) 2))
(vla-put-ConstantWidth entVLA A_Width)
  )
)
				;;
;;ONwidht change		;;

      
  
;;ONcolor change		;;
				;;
(if (eq Operation "COLOR")
  (progn
    (initget "E L C")
    (setq resp (getkword mess5))   

    (if (eq resp "E")
      (progn
	(setq ccol (read A_cecolor))
    (if (eq (strcase A_cecolor) "BYBLOCK") (setq ccol 0))
    (if (eq (strcase A_cecolor) "BYLAYER") (setq ccol 256))
    (setq Ncol (acad_colordlg ccol 8))
    (if Ncol
      (progn
        (setq A_cecolor (itoa Ncol))
        (if (eq A_cecolor 256)(setq A_cecolor var256))
        (if (eq A_cecolor 0)(setq A_cecolor var0))
       )
      )
    (vla-put-color entVLA Ncol)
      )
      (progn
	(setq ccol (read A_cecolor))
	(if (or (eq ccol 256)(eq ccol 0))
	  (setq Ncol (acad_colordlg 1 nil))
	  (setq Ncol (acad_colordlg ccol nil))
	)	  
    (if Ncol
      (progn
	(vla-put-color entVLA 256)
	(changelayercolor A_Clayer Ncol)
      )
    )
    )
    )
   (setq Operation nil)
    (princ Pmess)
  )
 )
				;;
;;ONcolor change		;;


      
      
;;ONlinetype change		;;
				;;
      (if (eq Operation "LINETYPE")
        (progn
          (setq Operation nil)
          (setq input (grread t 4 4))
               (if (>= #dcswitch #ofLTYPE)
                 (setq #dcswitch 0)
                 (setq #dcswitch (1+ #dcswitch))
               ) 
               (princ (strcat mess2
                              (setq A_Ltype (nth #dcswitch LTypelist))
                      )
               )               
               (princ mess3)

	  (if (and
		(/= A_Ltype "BYLAYER")(/= A_Ltype "BYBLOCK")
		(not (member (strcase A_Ltype)(getAvailableLinetypes)))
	      )
	    (vl-cmdf "._-linetype" "_L" A_Ltype "" "")
	  )
	  (vla-put-Linetype entVLA A_LType)
        )
	
      )
				;;
;;ONlinetype change		;;


	
;;SWITCH ORTHOMODE		;;
				;;
(if (eq Operation "ORTHO")
  (progn
    (if (eq orthm 1)
           (progn (setvar "ORTHOMODE" 0) (setq orthm 0))
           (progn (setvar "ORTHOMODE" 1) (setq orthm 1))
         )
  )
)
(if (eq orthM 1)
  (HOSortho) 
  )      
				;;
;;SWITCH ORTHOMODE		;;

      
;;SWITCH SCALE			;;
				;;
(if (eq Operation "SCALE")
  (progn
(setq A_LTscale (/ (+ A_CELTscale (distance cursorpoint centerpoint)) 3))
(vla-put-LinetypeScale entVLA A_LTscale)
  )
)
				;;
;;SWITCH SCALE			;;

(grdraw cursorpoint centerpoint 4 1)
(princ)
)
)
				;;
;;				;;
;;	DLedit 	function	;;
;;				;;





;;				;;
;;	Change Layer Color	;;
;;Code proposed by Ronjon (theswamp)
;;				;;
				;;
(defun changelayercolor	(name color / lyr)
  (setq lyr (entget (tblobjname "layer" name)))
  (entmod (subst (cons 62 color) (assoc 62 lyr) lyr))
)
				;;
;;				;;
;;	Change Layer Color	;;
;;				;;




;;				;;
;;	ORTHOMODE		;;
;;				;;
				;;
(defun HOSortho ()
  
(defun dtr (a)
(* pi (/ a 180.0))
)

(defun rtd (a) 
(/ (* a 180) pi) 
) 
  
    (setq distP (distance centerpoint cursorpoint))
    (setq NorthP (polar centerpoint (+ snapA (dtr 90)) distP))
    (setq WestP  (polar centerpoint (+ snapA (dtr 180)) distP))
    (setq EastP  (polar centerpoint snapA distP))
    (setq SouthP (polar centerpoint (- snapA (dtr 90)) distP))
  
(if (and
      (< (distance cursorpoint NorthP) (distance cursorpoint WestP))
      (< (distance cursorpoint NorthP) (distance cursorpoint EastP))
      (< (distance cursorpoint NorthP) (distance cursorpoint SouthP))
    )
(setq cursorpoint NorthP)
)

(if (and
      (< (distance cursorpoint WestP) (distance cursorpoint NorthP))
      (< (distance cursorpoint WestP) (distance cursorpoint EastP))
      (< (distance cursorpoint WestP) (distance cursorpoint SouthP))
    )
(setq cursorpoint WestP)
)  

(if (and
      (< (distance cursorpoint EastP) (distance cursorpoint WestP))
      (< (distance cursorpoint EastP) (distance cursorpoint NorthP))
      (< (distance cursorpoint EastP) (distance cursorpoint SouthP))
    )
(setq cursorpoint EastP)
)

(if (and
      (< (distance cursorpoint SouthP) (distance cursorpoint WestP))
      (< (distance cursorpoint SouthP) (distance cursorpoint EastP))
      (< (distance cursorpoint SouthP) (distance cursorpoint NorthP))
    )
(setq cursorpoint SouthP)
)  
)
				;;
;;				;;
;; 	ORTHOMODE		;;
;;				;;




;;				;;
;;	LIN file reader		;;
;;				;;
				;;
(defun getHatchLIN (acadftype / lino l1 commaPos ALLLIST)
(setq HATCHLIST nil
      LINESLIST nil)
(if (findfile acadftype)
  (progn
  (setq lino (open acadftype "r"))
  (while (setq l1 (read-line lino))
    (if (and
          (eq (substr l1 1 1) "*")
          (setq commaPos (vl-string-search "," l1))
        )
      (setq ALLLIST (append ALLLIST (list (substr l1 2 (1- commaPos)))))
    )
  )
)
)
(close lino)

(setq LINESLIST (mapcar 'strcase ALLLIST))  
)
				;;
;;				;;
;;	PAT or LIN file reader	;;
;;				;;



  
;;				;;
;;	Available LINETYPES	;;
;;				;;
				;;
(defun getAvailableLinetypes ()
(setq LT (vla-get-Linetypes (vla-get-ActiveDocument (vlax-get-ACAD-Object))))

(vlax-for l (vla-get-Linetypes (vla-get-ActiveDocument (vlax-get-ACAD-Object)))
(setq avLT (append avLT (list (vla-get-name l))))
)
(mapcar 'strcase avLT)
)
				;;
;;				;;
;;	Available LINETYPES	;;
;;				;;






